/**
 * @file rain_effect.h
 */

#ifndef _RAIN_EFFECT
#define _RAIN_EFFECT

#include "vector.h"
#include "vector2D.h"

#include "particle_system.h"

class SparkParticles;
class PlainEmitter;

#include "weather_effect.h"


class RainEffect : public WeatherEffect
{
  public:
    RainEffect(const TiXmlElement* root = NULL);
    virtual ~RainEffect();

    virtual void loadParams(const TiXmlElement* root);

    virtual bool init();

    virtual bool activate();
    virtual bool deactivate();

    inline void setRainCoord(float x, float y, float z) { this->rainCoord = Vector(x, y, z); }
    inline void setRainSize(float x, float y) { this->rainSize = Vector2D(x, y); }
    inline void setRainRate(float rate) { this->rainRate = rate;}
    inline void setRainVelocity(float velocity) { this->rainVelocity = velocity; }

  private:
    static SparkParticles*            rainParticles;
    ParticleEmitter*                  emitter;

    Vector                            rainCoord;
    Vector2D                          rainSize;
    GLfloat                           rainRate;
    GLfloat                           rainVelocity;
};


#endif  /* _RAIN_EFFECT */
